## deepin-movie-reborn 5.9.14

=== src/CMakeLists.txt ===
set(CMAKE_AUTOMOC ON)
set(CMD_NAME deepin-movie)

set(PROJECT_INCLUDE ${PROJECT_SOURCE_DIR}/src/widgets
    ${PROJECT_SOURCE_DIR}/src/common
    ${PROJECT_SOURCE_DIR}/src/libdmr)

add_definitions(-D_MOVIE_USE_)

include_directories(${CMAKE_INCLUDE_CURRENT_DIR})
include_directories(${CMAKE_CURRENT_BINARY_DIR})

find_package(Qt5Widgets)
find_package(Qt5DBus)
find_package(Qt5X11Extras)
find_package(Qt5LinguistTools)
find_package(Qt5Network)
find_package(Qt5Concurrent)
find_package(Qt5Sql)
find_package(Qt5Svg)
find_package(gui-private)

pkg_check_modules(Dtk REQUIRED IMPORTED_TARGET dtkwidget)
pkg_check_modules(Dtk REQUIRED IMPORTED_TARGET dtkcore)
pkg_check_modules(Xcb REQUIRED IMPORTED_TARGET xcb xcb-shape)
pkg_check_modules(MPRIS REQUIRED IMPORTED_TARGET mpris-qt5)
pkg_check_modules(DBusextended REQUIRED IMPORTED_TARGET dbusextended-qt5)
# IMPORTED_TARGET failed to work for some of libs under flatpak env
pkg_check_modules(Other REQUIRED  gsettings-qt)

qt5_add_resources(RCS ../assets/resources.qrc)
qt5_add_resources(RCS ../assets/icons/theme-icons.qrc)
if (${Dtk_VERSION} LESS 2.0.6.1)
    qt5_add_resources(RCS ../assets/theme.qrc)
endif()


file(GLOB_RECURSE SRCS LIST_DIRECTORIES false common/*.cpp widgets/*.cpp libdmr/*.cpp vendor/*.cpp)
list(APPEND SRCS main.cpp)

# mpv backend
file(GLOB_RECURSE MPV_SRCS LIST_DIRECTORIES false backends/mpv/*.cpp)
list(APPEND SRCS ${MPV_SRCS})
list(APPEND PROJECT_INCLUDE ${PROJECT_SOURCE_DIR}/src/backends/mpv)
#~

set (DTK_SETTINGS_TOOLS_EXECUTABLE ${DTKCORE_TOOL_DIR}/dtk-settings)
if (EXISTS ${DTK_SETTINGS_TOOLS_EXECUTABLE})
add_custom_target(json_i18n ALL
        ${DTKCORE_TOOL_DIR}/dtk-settings resources/data/settings.json -o common/settings_translation.cpp
    COMMAND sed -i "s,#include .*,#include <DSettings>," common/settings_translation.cpp
    VERBATIM
    SOURCES resources/data/settings.json
    WORKING_DIRECTORY ${PROJECT_SOURCE_DIR}/src/)

endif ()
## translations
file(GLOB TS LIST_DIRECTORIES false ../translations/${CMD_NAME}*.ts)

set_source_files_properties(${TS}
    PROPERTIES OUTPUT_LOCATION ${PROJECT_SOURCE_DIR}/translations)

if (NOT (${CMAKE_BUILD_TYPE} MATCHES "Debug"))
    qt5_create_translation(QM ${SRCS} ${TS})
endif ()
# ~

add_executable(${CMD_NAME} ${SRCS} ${RCS} ${QM})

target_include_directories(${CMD_NAME} PUBLIC ${PROJECT_INCLUDE})

set(TARGET_LIBS X11 Xtst PkgConfig::Xcb Qt5::Widgets Qt5::X11Extras Qt5::Network Qt5::GuiPrivate
    Qt5::DBus Qt5::Sql Qt5::Svg PkgConfig::Dtk PkgConfig::MPRIS PkgConfig::DBusextended GL va va-x11)

target_link_libraries(${CMD_NAME} ${TARGET_LIBS} ${Other_LIBRARIES})


install(TARGETS ${CMD_NAME} DESTINATION bin)
install(DIRECTORY ${PROJECT_SOURCE_DIR}/translations
    DESTINATION share/${CMD_NAME}
    FILES_MATCHING PATTERN "*.qm")
install(FILES ${PROJECT_SOURCE_DIR}/deepin-movie.desktop
    DESTINATION share/applications)
install(FILES ${CMAKE_SOURCE_DIR}/src/libdmr/com.deepin.deepin-movie.gschema.xml
    DESTINATION /usr/share/glib-2.0/schemas)
install(FILES ${PROJECT_SOURCE_DIR}/assets/resources/icons/logo-big.svg
    DESTINATION share/icons/hicolor/scalable/apps
    RENAME deepin-movie.svg)
install(DIRECTORY ${CMAKE_SOURCE_DIR}/assets/deepin-movie DESTINATION /usr/share/deepin-manual/manual-assets/application/)

#匹配mpris差异
execute_process(COMMAND dpkg -s libmpris-qt5-1 COMMAND grep -i version COMMAND cut -d\  -f2 OUTPUT_VARIABLE libmprisVersion)
message(${libmprisVersion})
if( ${libmprisVersion} MATCHES "0.1.0-" )
    add_definitions(-D_LIBMPR_)
endif()

# 加速编译优化参数
if (CMAKE_HOST_SYSTEM_PROCESSOR MATCHES "mips64")
    SET(CMAKE_CXX_FLAGS "$ENV{CXXFLAGS} -O3 -ftree-vectorize -march=loongson3a -mhard-float -mno-micromips -mno-mips16 -flax-vector-conversions -mloongson-ext2 -mloongson-mmi -Wl,--as-need -fPIE -z noexecstack")
    SET(CMAKE_C_FLAGS "$ENV{CFLAGS} -O3 -ftree-vectorize -march=loongson3a -mhard-float -mno-micromips -mno-mips16 -flax-vector-conversions -mloongson-ext2 -mloongson-mmi -z noexecstack")
    SET(CMAKE_EXE_LINKER_FLAGS "-pie")
else()
    SET(CMAKE_CXX_FLAGS "$ENV{CXXFLAGS} -fstack-protector-strong -Wformat -Werror=format-security -Wdate-time -D_FORTIFY_SOURCE=2 -std=c++14 -O3 -DNDEBUG -fPIC -Wl,--as-need -fPIE")
    SET(CMAKE_C_FLAGS "$ENV{CFLAGS} -fstack-protector-strong -Wformat -Werror=format-security -Wdate-time -D_FORTIFY_SOURCE=2 -std=c++14 -O3 -DNDEBUG -fPIC")
    SET(CMAKE_EXE_LINKER_FLAGS "-pie")
endif()

add_subdirectory(libdmr)
#add_subdirectory(test)

=== examples/test/CMakeLists.txt ===

project(libdmr_test)

set(CMAKE_AUTOMOC ON)
set(CMD_NAME dmr_test)

set(CMAKE_CXX_FLAGS "-std=c++1y -fpermissive -Wno-error")

include_directories(${CMAKE_INCLUDE_CURRENT_DIR})

find_package(Qt5Widgets)
find_package(Qt5Concurrent)
find_package(Qt5Network)
find_package(Qt5X11Extras)
find_package(Qt5Sql)
find_package(Qt5DBus)
find_package(Qt5Svg)

pkg_check_modules(Dtk REQUIRED IMPORTED_TARGET dtkwidget)
pkg_check_modules(AV REQUIRED IMPORTED_TARGET libavformat libavutil libavcodec)

# 定义 source 文件
FILE (GLOB SRCS
    *.cpp
    )

add_executable(${CMD_NAME} ${SRCS})

target_link_libraries(${CMD_NAME} PkgConfig::Dtk Qt5::Widgets Qt5::Concurrent
    Qt5::Network Qt5::X11Extras Qt5::Sql Qt5::DBus PkgConfig::AV
    ${FFTHUMB_LIBRARIES} GL)
target_include_directories(${CMD_NAME} PUBLIC 
    ${PROJECT_SOURCE_DIR}/../../src/libdmr
    ${PROJECT_SOURCE_DIR})

target_link_libraries(${CMD_NAME} Qt5::Widgets dmr)

=== src/libdmr/CMakeLists.txt ===
project(libdmr VERSION 0.1.0)

set(CMAKE_AUTOMOC ON)
set(CMD_NAME dmr)

add_definitions(-D_LIBDMR_)
remove_definitions(-D_MOVIE_USE_)

pkg_check_modules(FFTHUMB REQUIRED libffmpegthumbnailer)
pkg_check_modules(AV REQUIRED IMPORTED_TARGET libavformat libavutil libavcodec)

include_directories(${CMAKE_INCLUDE_CURRENT_DIR})

file(GLOB_RECURSE SRCS LIST_DIRECTORIES false *.cpp)
file(GLOB_RECURSE MPV_SRCS LIST_DIRECTORIES false ../backends/mpv/*.cpp)
file(GLOB_RECURSE HWDEC_SRCS ../common/hwdec_probe.cpp)
list(APPEND SRCS player_widget.cpp ${MPV_SRCS} ${HWDEC_SRCS})

add_library(${CMD_NAME} SHARED ${SRCS})
set_target_properties(${CMD_NAME} PROPERTIES VERSION 0.1.0 SOVERSION 0.1)

target_include_directories(${CMD_NAME} PUBLIC
    ${PROJECT_SOURCE_DIR}/../common ${PROJECT_SOURCE_DIR}/../backends/mpv)

target_link_libraries(${CMD_NAME} PkgConfig::Dtk Qt5::Widgets Qt5::Concurrent
    Qt5::Network Qt5::X11Extras Qt5::Sql Qt5::Svg Qt5::DBus PkgConfig::AV
    ${FFTHUMB_LIBRARIES} GL)
#target_link_libraries(${CMD_NAME} PkgConfig::Dtk Qt5::Widgets Qt5::Concurrent
#    Qt5::Network Qt5::X11Extras Qt5::Sql Qt5::DBus PkgConfig::AV GL png jpeg)


include(GNUInstallDirs)

configure_file(libdmr.pc.in ${PROJECT_BINARY_DIR}/libdmr.pc @ONLY)

install(TARGETS ${CMD_NAME} DESTINATION ${CMAKE_INSTALL_LIBDIR})
install(FILES
    player_widget.h
    player_backend.h
    player_engine.h
    playlist_model.h
    movie_configuration.h
    compositing_manager.h
    utils.h
    online_sub.h
    DESTINATION include/libdmr)

install(FILES ${PROJECT_BINARY_DIR}/libdmr.pc DESTINATION ${CMAKE_INSTALL_LIBDIR}/pkgconfig)

=== tests/deepin-movie-platform/CMakeLists.txt ===
# 定义需要的cmake版本
cmake_minimum_required(VERSION 3.10)

# 设置cmake参数
set(CMAKE_CXX_STANDARD 14)
set(CMAKE_INCLUDE_CURRENT_DIR ON)
set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTORCC ON)
set(CMAKE_AUTOUIC ON)

#ADD_DEFINITIONS( -LITE_DIV)
execute_process(COMMAND uname -m OUTPUT_VARIABLE MACH
    ERROR_QUIET OUTPUT_STRIP_TRAILING_WHITESPACE)

option (USE_TEST "Use TESTS" ON)
add_definitions( -DUSE_TEST )

# 设置Qt模块
set(QtModule Core Gui Widgets Network X11Extras PrintSupport DBus Sql Svg Concurrent LinguistTools Test)

# 设置工程名字
project(deepin-movie-platform-test)

# 查找Qt相关的库链接
find_package(Qt5 REQUIRED ${QtModule})
find_package(gui-private)


# 包含源码文件夹
include_directories(${CMAKE_INCLUDE_CURRENT_DIR})
include_directories(${CMAKE_CURRENT_BINARY_DIR})

include_directories(../../src)
include_directories(../../src/common)
include_directories(../../src/common/platform)
include_directories(../../src/widgets)
include_directories(../../src/widgets/platform)
include_directories(../../src/libdmr)
include_directories(../../src/vendor)
include_directories(../../src/backends)
include_directories(../../src/backends/mpv)

#add_subdirectory(googletest)

# 定义 source 文件
FILE (GLOB allSource
    ../../src/common/*.cpp
    ../../src/common/platform/*.cpp
    ../../src/widgets/*.cpp
    ../../src/widgets/platform/*.cpp
    ../../src/libdmr/*.cpp
    ../../src/vendor/*.cpp
    ../../src/backends/mpv/*.cpp
    ../../src/backends/*.cpp
    )

FILE (GLOB allTestSource
    *.cpp
    *.sh
    common/*.cpp
    widgets/*.cpp
    libdmr/*.cpp
    backends/*.cpp
    vendor/*.cpp
    *.sh
    )

# 定义资源文件
set(AllQRC
    ../../assets/resources.qrc
    ../../assets/icons/theme-icons.qrc
)

# 设置不删除生成的文件夹内容文件（设置此项是为了翻译后的文件不被删除）
set_directory_properties(PROPERTIES CLEAN_NO_CUSTOM 1)

# 添加需要安装的模块
add_executable(${PROJECT_NAME} ${allSource} ${allTestSource}
    ${AllQRC}
    )

# 添加gocv覆盖率文件的输出
if (CMAKE_HOST_SYSTEM_PROCESSOR MATCHES "mips64")
    set(CMAKE_CXX_FLAGS "-g -fprofile-arcs -ftest-coverage")    #mips平台下不进行内存检测
else()
    set(CMAKE_CXX_FLAGS "-fsanitize=undefined,address,leak -fno-omit-frame-pointer -g -fprofile-arcs -ftest-coverage")
    set(CMAKE_C_FLAGS "-fsanitize=undefined,address,leak -fno-omit-frame-pointer")
    set(CMAKE_L_FLAGS "-fsanitize=undefined,address,leak -fno-omit-frame-pointer")
endif()

set(CMAKE_CXX_OUTPUT_EXTENSION_REPLACE ON)

set(OBJECT_DIR ${CMAKE_BINARY_DIR}/CMakeFiles/objects)

add_custom_target(platform_test
    COMMAND mkdir -p build-ut
    COMMAND mkdir -p build-ut/report
    WORKING_DIRECTORY ${CMAKE_BINARY_DIR})

add_custom_command(TARGET platform_test
    COMMAND echo " ===================CREAT LCOV REPROT==================== "
    COMMAND lcov --directory ./CMakeFiles/${PROJECT_NAME}.dir --zerocounters
    COMMAND ./tests/${PROJECT_NAME} #-o ./build-ut/report/report_${PROJECT_NAME}.xml,xml
    COMMAND lcov --directory . --capture --output-file ./build-ut/${PROJECT_NAME}_Coverage.info

    COMMAND echo " =================== do filter begin ==================== "
    COMMAND lcov --remove ./build-ut/${PROJECT_NAME}_Coverage.info 'CMakeFiles/${PROJECT_NAME}.dir/${PROJECT_NAME}_autogen/*/*'
    '${PROJECT_NAME}_autogen/*/*/*.cpp' 'googletest/*/*' '*/usr/include/*' '*/tests/*' '/usr/local/*' '*/src/common/filter.*'
    '*/src/common/settings_translation.cpp' '*/src/common/event_monitor.cpp' '*/src/widgets/videoboxbutton.cpp' '*/src/common/event_relayer.cpp'
    -o ./build-ut/${PROJECT_NAME}_Coverage_fileter.info
    COMMAND echo " =================== do filter end ==================== "

    COMMAND genhtml -o ./build-ut/report ./build-ut/${PROJECT_NAME}_Coverage_fileter.info
    COMMAND echo " -- Coverage files have been output to ${CMAKE_BINARY_DIR}/build-ut/report "
    WORKING_DIRECTORY ${CMAKE_BINARY_DIR}
    )
add_dependencies(platform_test ${PROJECT_NAME})

#------------------------------ 添加第三方库  DTK -------------------------------
# 使用第三方库需要用到的一个包
find_package(PkgConfig REQUIRED)
#set(TARGET_LIBS X11 Xext Xtst PkgConfig::Xcb Qt5::Widgets Qt5::X11Extras Qt5::Network
#    Qt5::Concurrent Qt5::DBus Qt5::Sql PkgConfig::Dtk
#    PkgConfig::Mpv PkgConfig::MPRIS PkgConfig::DBusextended
#    PkgConfig::AV pthread GL)
# 检查第三方库(这里检查了名字为dtkwidget的库和名字为dtkgui的库)，然后取名3rd_lib
pkg_check_modules(3rd_lib REQUIRED
        dtkwidget dtkgui libffmpegthumbnailer
        libpulse dvdnav gsettings-qt  mpv x11 xext xtst xcb gl
        libavformat libavcodec libavutil
        xcb-aux xcb-proto xcb-ewmh xcb-shape mpris-qt5 dbusextended-qt5 libva libva-x11
        )
    #libpulse-simple xcb-aux gtest
# 添加第三方库的所有文件夹路径到工程中来(注意 *_INCLUDE_DIRS)
target_include_directories(${PROJECT_NAME} PUBLIC ${3rd_lib_INCLUDE_DIRS} )

# 将第三方库链接进来(注意 *_LIBRARIES)
target_link_libraries(${PROJECT_NAME} ${3rd_lib_LIBRARIES}  Qt5::GuiPrivate)
#------------------------------添加第三方库end-------------------------------------

target_link_libraries(${PROJECT_NAME} gmock gmock_main gtest gtest_main)

# 将工程与Qt模块链接起来
qt5_use_modules(${PROJECT_NAME} ${QtModule})

=== tests/deepin-movie/CMakeLists.txt ===
# 定义需要的cmake版本
cmake_minimum_required(VERSION 3.10)

# 设置cmake参数
set(CMAKE_CXX_STANDARD 14)
set(CMAKE_INCLUDE_CURRENT_DIR ON)
set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTORCC ON)
set(CMAKE_AUTOUIC ON)

#ADD_DEFINITIONS( -LITE_DIV)
execute_process(COMMAND uname -m OUTPUT_VARIABLE MACH
    ERROR_QUIET OUTPUT_STRIP_TRAILING_WHITESPACE)

option (USE_TEST "Use TESTS" ON)
add_definitions( -DUSE_TEST )

# 设置Qt模块
set(QtModule Core Gui Widgets Network X11Extras PrintSupport DBus Sql Svg Concurrent LinguistTools Test)

# 设置工程名字
project(deepin-movie-test)

# 查找Qt相关的库链接
find_package(Qt5 REQUIRED ${QtModule})
find_package(gui-private)


# 包含源码文件夹
include_directories(${CMAKE_INCLUDE_CURRENT_DIR})
include_directories(${CMAKE_CURRENT_BINARY_DIR})

include_directories(../../src)
include_directories(../../src/common)
include_directories(../../src/common/platform)
include_directories(../../src/widgets)
include_directories(../../src/widgets/platform)
include_directories(../../src/libdmr)
include_directories(../../src/vendor)
include_directories(../../src/backends)
include_directories(../../src/backends/mpv)

#add_subdirectory(googletest)

# 定义 source 文件
FILE (GLOB allSource
    ../../src/common/*.cpp
    ../../src/common/platform/*.cpp
    ../../src/widgets/*.cpp
    ../../src/widgets/platform/*.cpp
    ../../src/libdmr/*.cpp
    ../../src/vendor/*.cpp
    ../../src/backends/mpv/*.cpp
    ../../src/backends/*.cpp
    )

FILE (GLOB allTestSource
    *.cpp
    *.sh
    common/*.cpp
    widgets/*.cpp
    libdmr/*.cpp
    backends/*.cpp
    vendor/*.cpp
    stub/*.cpp
    *.sh
    )

# 定义资源文件
set(AllQRC
    ../../assets/resources.qrc
    ../../assets/icons/theme-icons.qrc
)

# 设置不删除生成的文件夹内容文件（设置此项是为了翻译后的文件不被删除）
set_directory_properties(PROPERTIES CLEAN_NO_CUSTOM 1)

# 添加需要安装的模块
add_executable(${PROJECT_NAME} ${allSource} ${allTestSource}
    ${AllQRC}
    )

# 添加gocv覆盖率文件的输出
if (CMAKE_HOST_SYSTEM_PROCESSOR MATCHES "mips64")
    set(CMAKE_CXX_FLAGS "-g -fprofile-arcs -ftest-coverage")    #mips平台下不进行内存检测
else()
    set(CMAKE_CXX_FLAGS "-fsanitize=undefined,address,leak -fno-omit-frame-pointer -g -fprofile-arcs -ftest-coverage")
    set(CMAKE_C_FLAGS "-fsanitize=undefined,address,leak -fno-omit-frame-pointer")
    set(CMAKE_L_FLAGS "-fsanitize=undefined,address,leak -fno-omit-frame-pointer")
endif()

set(CMAKE_CXX_OUTPUT_EXTENSION_REPLACE ON)

set(OBJECT_DIR ${CMAKE_BINARY_DIR}/CMakeFiles/objects)

add_custom_target(test
    COMMAND mkdir -p build-ut
    COMMAND mkdir -p build-ut/report
    WORKING_DIRECTORY ${CMAKE_BINARY_DIR})

add_custom_command(TARGET test
    COMMAND echo " ===================CREAT LCOV REPROT==================== "
    COMMAND lcov --directory ./CMakeFiles/${PROJECT_NAME}.dir --zerocounters
    COMMAND ./tests/${PROJECT_NAME} #-o ./build-ut/report/report_${PROJECT_NAME}.xml,xml
    COMMAND lcov --directory . --capture --output-file ./build-ut/${PROJECT_NAME}_Coverage.info

    COMMAND echo " =================== do filter begin ==================== "
    COMMAND lcov --remove ./build-ut/${PROJECT_NAME}_Coverage.info 'CMakeFiles/${PROJECT_NAME}.dir/${PROJECT_NAME}_autogen/*/*'
    '${PROJECT_NAME}_autogen/*/*/*.cpp' 'googletest/*/*' '*/usr/include/*' '*/tests/*' '/usr/local/*' '*/src/common/filter.*'
    '*/src/common/settings_translation.cpp' '*/src/common/event_monitor.cpp' '*/src/widgets/videoboxbutton.cpp' '*/src/common/event_relayer.cpp'
    -o ./build-ut/${PROJECT_NAME}_Coverage_fileter.info
    COMMAND echo " =================== do filter end ==================== "

    COMMAND genhtml -o ./build-ut/report ./build-ut/${PROJECT_NAME}_Coverage_fileter.info
    COMMAND echo " -- Coverage files have been output to ${CMAKE_BINARY_DIR}/build-ut/report "
    WORKING_DIRECTORY ${CMAKE_BINARY_DIR}
    )
add_dependencies(test ${PROJECT_NAME})

#------------------------------ 添加第三方库  DTK -------------------------------
# 使用第三方库需要用到的一个包
find_package(PkgConfig REQUIRED)
#set(TARGET_LIBS X11 Xext Xtst PkgConfig::Xcb Qt5::Widgets Qt5::X11Extras Qt5::Network
#    Qt5::Concurrent Qt5::DBus Qt5::Sql PkgConfig::Dtk
#    PkgConfig::Mpv PkgConfig::MPRIS PkgConfig::DBusextended
#    PkgConfig::AV pthread GL)
# 检查第三方库(这里检查了名字为dtkwidget的库和名字为dtkgui的库)，然后取名3rd_lib
pkg_check_modules(3rd_lib REQUIRED
        dtkwidget dtkgui libffmpegthumbnailer
        libpulse dvdnav gsettings-qt  mpv x11 xext xtst xcb gl
        libavformat libavcodec libavutil
        xcb-aux xcb-proto xcb-ewmh xcb-shape mpris-qt5 dbusextended-qt5 libva libva-x11
        )
    #libpulse-simple xcb-aux gtest
# 添加第三方库的所有文件夹路径到工程中来(注意 *_INCLUDE_DIRS)
target_include_directories(${PROJECT_NAME} PUBLIC ${3rd_lib_INCLUDE_DIRS} )

# 将第三方库链接进来(注意 *_LIBRARIES)
target_link_libraries(${PROJECT_NAME} ${3rd_lib_LIBRARIES}  Qt5::GuiPrivate)
#------------------------------添加第三方库end-------------------------------------

target_link_libraries(${PROJECT_NAME} gmock gmock_main gtest gtest_main)

# 将工程与Qt模块链接起来
qt5_use_modules(${PROJECT_NAME} ${QtModule})

=== tests/ut_dmr-test/CMakeLists.txt ===
# 设置工程名字
project(ut_dmr-test)

# 定义需要的cmake版本
cmake_minimum_required(VERSION 3.10)

# 设置cmake参数
set(CMAKE_CXX_STANDARD 14)
set(CMAKE_INCLUDE_CURRENT_DIR ON)
set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTORCC ON)
set(CMAKE_AUTOUIC ON)

execute_process(COMMAND uname -m OUTPUT_VARIABLE MACH
    ERROR_QUIET OUTPUT_STRIP_TRAILING_WHITESPACE)

option (USE_TEST "Use TESTS" ON)
add_definitions( -DUSE_TEST )

# 设置Qt模块
set(QtModule Core Gui Widgets Network X11Extras PrintSupport DBus Sql Svg Concurrent LinguistTools Test)

# 查找Qt相关的库链接
find_package(Qt5 REQUIRED ${QtModule})

pkg_check_modules(Dtk REQUIRED IMPORTED_TARGET dtkwidget)
pkg_check_modules(AV REQUIRED IMPORTED_TARGET libavformat libavutil libavcodec)

include_directories(../../examples/test)
include_directories(../../src)
include_directories(../../src/common)
include_directories(../../src/widgets)
include_directories(../../src/libdmr)
include_directories(../../src/vendor)
include_directories(../../src/backends)
include_directories(../../src/backends/mpv)

# 定义 source 文件
FILE (GLOB allSource
    ../../examples/test/window.cpp
    )

FILE (GLOB allTestSource
    *.cpp
    *.sh
    )

# 定义资源文件
set(AllQRC
    ../../assets/resources.qrc
    ../../assets/icons/theme-icons.qrc
)

add_executable(${PROJECT_NAME} ${allSource} ${allTestSource} ${AllQRC})

#添加内存泄露检测参数
if (CMAKE_HOST_SYSTEM_PROCESSOR MATCHES "mips64")
    set(CMAKE_CXX_FLAGS "-g -fprofile-arcs -ftest-coverage")    #mips平台下不进行内存检测
else()
    set(CMAKE_CXX_FLAGS "-fsanitize=undefined,address,leak -fno-omit-frame-pointer -g -fprofile-arcs -ftest-coverage")
    set(CMAKE_C_FLAGS "-fsanitize=undefined,address,leak -fno-omit-frame-pointer")
    set(CMAKE_L_FLAGS "-fsanitize=undefined,address,leak -fno-omit-frame-pointer")
endif()

set(CMAKE_CXX_OUTPUT_EXTENSION_REPLACE ON)

set(OBJECT_DIR ${CMAKE_BINARY_DIR}/CMakeFiles/objects)

# 使用第三方库需要用到的一个包
find_package(PkgConfig REQUIRED)
pkg_check_modules(3rd_lib REQUIRED
        dtkwidget dtkgui libffmpegthumbnailer
        libpulse dvdnav gsettings-qt  mpv x11 xext xtst xcb gl
        libavformat libavcodec libavutil
        xcb-aux xcb-proto xcb-ewmh xcb-shape mpris-qt5 dbusextended-qt5 libva libva-x11
        )
    #libpulse-simple xcb-aux gtest
# 添加第三方库的所有文件夹路径到工程中来(注意 *_INCLUDE_DIRS)
target_include_directories(${PROJECT_NAME} PUBLIC ${3rd_lib_INCLUDE_DIRS})

# 将第三方库链接进来(注意 *_LIBRARIES)
target_link_libraries(${PROJECT_NAME} ${3rd_lib_LIBRARIES} )
#------------------------------添加第三方库end-------------------------------------

target_link_libraries(${PROJECT_NAME} gmock gmock_main gtest gtest_main dmr)

# 将工程与Qt模块链接起来
qt5_use_modules(${PROJECT_NAME} ${QtModule})

=== debian/changelog ===
deepin-movie-reborn (5.9.14-1) unstable; urgency=medium

  * update

 -- Deepin Packages Builder <packages@deepin.com>  Fri, 18 Mar 2022 16:50:00 +0800

deepin-movie-reborn (3.0.0-1) unstable; urgency=low

  * First release.

 -- Sian Cao <yinshuiboy@gmail.com>  Wed, 15 Mar 2017 16:40:00 +0800

=== debian/control ===
Source: deepin-movie-reborn
Section: libdevel
Priority: extra
Maintainer: Deepin Packages Builder <packages@deepin.com>
Build-Depends: debhelper, cmake, pkg-config, qttools5-dev-tools,
                libqt5svg5-dev, qtmultimedia5-dev, qttools5-dev,
                libqt5x11extras5-dev, libdtkcore5-bin, libdtkwidget-dev,
                libqt5sql5-sqlite,
                libmpv-dev, libxcb1-dev, libxcb-util0-dev,
                libffmpegthumbnailer-dev,
                libxcb-shape0-dev,libxcb-ewmh-dev, xcb-proto,
                x11proto-record-dev, libxtst-dev,
                libavcodec-dev, libavformat-dev,libavutil-dev,
                libpulse-dev, libdvdnav-dev, libgsettings-qt-dev,
                libmpris-qt5-dev, libdbusextended-qt5-dev, libva-dev, qtbase5-private-dev
Standards-Version: 3.9.8
Homepage: https://www.deepin.org/

Package: deepin-movie
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, va-driver-all, libavcodec58(>= 7:4.0), libavformat58(>= 7:4.1), libavutil56(>= 7:4.0), libffmpegthumbnailer4v5, libmpv1(>= 0.29), libpulse0(>= 0.99.1), libqt5concurrent5, libmpris-qt5-1
Recommends: libgpuinfo
Description: movie player
 Movie is a full-featured video player, supporting playing local and streaming media in multiple video formats.

Package: libdmr
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libavcodec58(>= 7:4.0), libavformat58(>= 7:4.1), libavutil56(>= 7:4.0), libffmpegthumbnailer4v5, libmpv1(>= 0.29), libpulse0(>= 0.99.1), libqt5concurrent5, libmpris-qt5-1
Multi-Arch: same
Description: movie player widget library 
 deepin movie player widget library

Package: libdmr-dev
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libdmr(=${binary:Version}), libgsettings-qt-dev
Description: movie player widget library development headers
 deepin movie player widget library development headers

## deepin-movie-reborn 5.10.1

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.0)

project(deepin-movie-reborn)


option(USE_DXCB "integration with dxcb platform plugin" OFF)
option(DMR_DEBUG "turn on debug output" off)
option(DTK_DMAN_PORTAL "turn on dman portal support" off)

execute_process(COMMAND uname -m OUTPUT_VARIABLE MACH
    ERROR_QUIET OUTPUT_STRIP_TRAILING_WHITESPACE)

if (CMAKE_BUILD_TYPE STREQUAL "Debug")
    set(DMR_DEBUG on)
endif()

if (CMAKE_CXX_COMPILER_ID STREQUAL "GNU")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++11")
endif()

set(CMAKE_EXPORT_COMPILE_COMMANDS on)

find_package(PkgConfig REQUIRED)

# Find includes in corresponding build directories
set(CMAKE_INCLUDE_CURRENT_DIR ON)

include_directories(${PROJECT_BINARY_DIR})
include_directories(${PROJECT_SOURCE_DIR})

configure_file(${PROJECT_SOURCE_DIR}/config.h.in ${PROJECT_BINARY_DIR}/config.h @ONLY)

add_subdirectory(src)
add_subdirectory(examples/test)

if (CMAKE_BUILD_TYPE STREQUAL "Debug")
    add_subdirectory(tests)
endif()

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -19,12 +19,15 @@
 find_package(Qt5Sql)
 find_package(Qt5Svg)
 find_package(gui-private)
+find_package(Qt5Multimedia)
+find_package(Qt5MultimediaWidgets)
 
 pkg_check_modules(Dtk REQUIRED IMPORTED_TARGET dtkwidget)
 pkg_check_modules(Dtk REQUIRED IMPORTED_TARGET dtkcore)
 pkg_check_modules(Xcb REQUIRED IMPORTED_TARGET xcb xcb-shape)
 pkg_check_modules(MPRIS REQUIRED IMPORTED_TARGET mpris-qt5)
 pkg_check_modules(DBusextended REQUIRED IMPORTED_TARGET dbusextended-qt5)
+pkg_check_modules(Gst REQUIRED IMPORTED_TARGET gstreamer-1.0 glib-2.0 gstreamer-pbutils-1.0)
 # IMPORTED_TARGET failed to work for some of libs under flatpak env
 pkg_check_modules(Other REQUIRED  gsettings-qt)
 
@@ -40,8 +43,11 @@
 
 # mpv backend
 file(GLOB_RECURSE MPV_SRCS LIST_DIRECTORIES false backends/mpv/*.cpp)
-list(APPEND SRCS ${MPV_SRCS})
+file(GLOB_RECURSE MEDIAPLAYER_SRCS LIST_DIRECTORIES false backends/mediaplayer/*.cpp)
+list(APPEND SRCS ${MPV_SRCS} ${MEDIAPLAYER_SRCS})
 list(APPEND PROJECT_INCLUDE ${PROJECT_SOURCE_DIR}/src/backends/mpv)
+list(APPEND PROJECT_INCLUDE ${PROJECT_SOURCE_DIR}/src/backends/mediaplayer)
+list(APPEND PROJECT_INCLUDE /usr/include/glib-2.0 /usr/include/gstreamer-1.0)
 #~
 
 set (DTK_SETTINGS_TOOLS_EXECUTABLE ${DTKCORE_TOOL_DIR}/dtk-settings)
@@ -70,7 +76,8 @@
 target_include_directories(${CMD_NAME} PUBLIC ${PROJECT_INCLUDE})
 
 set(TARGET_LIBS X11 Xtst PkgConfig::Xcb Qt5::Widgets Qt5::X11Extras Qt5::Network Qt5::GuiPrivate
-    Qt5::DBus Qt5::Sql Qt5::Svg PkgConfig::Dtk PkgConfig::MPRIS PkgConfig::DBusextended GL va va-x11)
+    Qt5::DBus Qt5::Sql Qt5::Svg Qt5::Multimedia Qt5::MultimediaWidgets PkgConfig::Dtk PkgConfig::MPRIS PkgConfig::DBusextended PkgConfig::Gst GL va va-x11
+    Qt5::Concurrent)
 
 target_link_libraries(${CMD_NAME} ${TARGET_LIBS} ${Other_LIBRARIES})

=== examples/test/CMakeLists.txt ===
--- 
+++ 
@@ -17,7 +17,7 @@
 find_package(Qt5Svg)
 
 pkg_check_modules(Dtk REQUIRED IMPORTED_TARGET dtkwidget)
-pkg_check_modules(AV REQUIRED IMPORTED_TARGET libavformat libavutil libavcodec)
+pkg_check_modules(Gst REQUIRED IMPORTED_TARGET gstreamer-1.0 glib-2.0)
 
 # 定义 source 文件
 FILE (GLOB SRCS
@@ -27,11 +27,11 @@
 add_executable(${CMD_NAME} ${SRCS})
 
 target_link_libraries(${CMD_NAME} PkgConfig::Dtk Qt5::Widgets Qt5::Concurrent
-    Qt5::Network Qt5::X11Extras Qt5::Sql Qt5::DBus PkgConfig::AV
-    ${FFTHUMB_LIBRARIES} GL)
+    Qt5::Network Qt5::X11Extras Qt5::Sql Qt5::DBus PkgConfig::Gst GL)
 target_include_directories(${CMD_NAME} PUBLIC 
     ${PROJECT_SOURCE_DIR}/../../src/libdmr
-    ${PROJECT_SOURCE_DIR})
+    ${PROJECT_SOURCE_DIR}
+    /usr/include/glib-2.0 /usr/include/gstreamer-1.0)
 
 target_link_libraries(${CMD_NAME} Qt5::Widgets dmr)

=== debian/changelog ===
deepin-movie-reborn (5.10.1-1) unstable; urgency=medium

  * update

 -- Deepin Packages Builder <packages@deepin.com>  Tue, 24 May 2022 11:30:33 +0800

=== debian/control ===
--- 
+++ 
@@ -12,7 +12,8 @@
                 x11proto-record-dev, libxtst-dev,
                 libavcodec-dev, libavformat-dev,libavutil-dev,
                 libpulse-dev, libdvdnav-dev, libgsettings-qt-dev,
-                libmpris-qt5-dev, libdbusextended-qt5-dev, libva-dev, qtbase5-private-dev
+                libmpris-qt5-dev, libdbusextended-qt5-dev, libva-dev, qtbase5-private-dev,
+                libgstreamer-plugins-base1.0-dev, libgstreamer1.0-dev
 Standards-Version: 3.9.8
 Homepage: https://www.deepin.org/

=== debian/rules ===
#!/usr/bin/make -f
include /usr/share/dpkg/default.mk
export QT_SELECT=5
DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

%:
	dh $@ --parallel

override_dh_auto_configure:
	dh_auto_configure -- \
	  -DCMAKE_BUILD_TYPE=Release \
	  -DCMAKE_INSTALL_PREFIX=/usr \
      -DAPP_VERSION=$(DEB_VERSION_UPSTREAM) -DVERSION=$(DEB_VERSION_UPSTREAM) LIB_INSTALL_DIR=/usr/lib/$(DEB_HOST_MULTIARCH) DH_AUTO_ARGS = --parallel --buildsystem=cmake

## deepin-movie-reborn 5.10.6

=== debian/changelog ===
deepin-movie-reborn (5.10.6-1) unstable; urgency=medium

  * update

 -- Deepin Packages Builder <packages@deepin.com>  Mon, 15 Aug 2022 09:19:41 +0800

deepin-movie-reborn (6.0.1) unstable; urgency=medium

  * New version 6.0.1.

 -- fengli <fengli@uniontech.com>  Tue, 13 Jul 2022 10:08:00 +0800

## deepin-movie-reborn 5.10.8

=== CMakeLists.txt ===
--- 
+++ 
@@ -22,6 +22,24 @@
 
 find_package(PkgConfig REQUIRED)
 
+pkg_check_modules(MPRIS REQUIRED IMPORTED_TARGET mpris-qt5)
+
+# test deepin fork mpris-qt5
+try_compile(USE_FORK_MPRIS
+              ${CMAKE_CURRENT_BINARY_DIR}/try_compile
+            SOURCES
+              ${CMAKE_CURRENT_SOURCE_DIR}/tests/mpris_test.cc
+            LINK_LIBRARIES
+              PkgConfig::MPRIS
+            OUTPUT_VARIABLE TRY_COMPILE_OUTPUT
+)
+
+message(STATUS "use deepin fork mpris-qt5: ${USE_FORK_MPRIS}")
+
+if(USE_FORK_MPRIS)
+  add_definitions(-DUSE_FORK_MPRIS)
+endif()
+
 # Find includes in corresponding build directories
 set(CMAKE_INCLUDE_CURRENT_DIR ON)

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -18,16 +18,14 @@
 find_package(Qt5Concurrent)
 find_package(Qt5Sql)
 find_package(Qt5Svg)
-find_package(gui-private)
 find_package(Qt5Multimedia)
 find_package(Qt5MultimediaWidgets)
 
 pkg_check_modules(Dtk REQUIRED IMPORTED_TARGET dtkwidget)
 pkg_check_modules(Dtk REQUIRED IMPORTED_TARGET dtkcore)
 pkg_check_modules(Xcb REQUIRED IMPORTED_TARGET xcb xcb-shape)
-pkg_check_modules(MPRIS REQUIRED IMPORTED_TARGET mpris-qt5)
 pkg_check_modules(DBusextended REQUIRED IMPORTED_TARGET dbusextended-qt5)
-pkg_check_modules(Gst REQUIRED IMPORTED_TARGET gstreamer-1.0 glib-2.0 gstreamer-pbutils-1.0)
+pkg_check_modules(Gst REQUIRED IMPORTED_TARGET gobject-2.0)
 # IMPORTED_TARGET failed to work for some of libs under flatpak env
 pkg_check_modules(Other REQUIRED  gsettings-qt)
 
@@ -75,8 +73,8 @@
 
 target_include_directories(${CMD_NAME} PUBLIC ${PROJECT_INCLUDE})
 
-set(TARGET_LIBS X11 Xtst PkgConfig::Xcb Qt5::Widgets Qt5::X11Extras Qt5::Network Qt5::GuiPrivate
-    Qt5::DBus Qt5::Sql Qt5::Svg Qt5::Multimedia Qt5::MultimediaWidgets PkgConfig::Dtk PkgConfig::MPRIS PkgConfig::DBusextended PkgConfig::Gst GL va va-x11
+set(TARGET_LIBS X11 Xtst PkgConfig::Xcb Qt5::Widgets Qt5::X11Extras Qt5::Network Qt5::DBus Qt5::Sql Qt5::Svg Qt5::Multimedia
+    Qt5::MultimediaWidgets PkgConfig::Dtk PkgConfig::MPRIS PkgConfig::DBusextended PkgConfig::Gst GL va va-x11
     Qt5::Concurrent)
 
 target_link_libraries(${CMD_NAME} ${TARGET_LIBS} ${Other_LIBRARIES})
@@ -95,13 +93,6 @@
     RENAME deepin-movie.svg)
 install(DIRECTORY ${CMAKE_SOURCE_DIR}/assets/deepin-movie DESTINATION /usr/share/deepin-manual/manual-assets/application/)
 
-#匹配mpris差异
-execute_process(COMMAND dpkg -s libmpris-qt5-1 COMMAND grep -i version COMMAND cut -d\  -f2 OUTPUT_VARIABLE libmprisVersion)
-message(${libmprisVersion})
-if( ${libmprisVersion} MATCHES "0.1.0-" )
-    add_definitions(-D_LIBMPR_)
-endif()
-
 # 加速编译优化参数
 if (CMAKE_HOST_SYSTEM_PROCESSOR MATCHES "mips64")
     SET(CMAKE_CXX_FLAGS "$ENV{CXXFLAGS} -O3 -ftree-vectorize -march=loongson3a -mhard-float -mno-micromips -mno-mips16 -flax-vector-conversions -mloongson-ext2 -mloongson-mmi -Wl,--as-need -fPIE -z noexecstack")

=== tests/CMakeLists.txt ===
# 定义需要的cmake版本
cmake_minimum_required(VERSION 3.10)

# 设置cmake参数
set(CMAKE_CXX_STANDARD 14)
set(CMAKE_INCLUDE_CURRENT_DIR ON)
set(CMAKE_AUTORCC ON)
set(CMAKE_AUTOUIC ON)

add_subdirectory(deepin-movie)
add_subdirectory(ut_dmr-test)
add_subdirectory(deepin-movie-platform)

=== src/libdmr/CMakeLists.txt ===
--- 
+++ 
@@ -6,25 +6,24 @@
 add_definitions(-D_LIBDMR_)
 remove_definitions(-D_MOVIE_USE_)
 
-pkg_check_modules(FFTHUMB REQUIRED libffmpegthumbnailer)
-pkg_check_modules(AV REQUIRED IMPORTED_TARGET libavformat libavutil libavcodec)
+pkg_check_modules(Gst REQUIRED IMPORTED_TARGET gstreamer-1.0 glib-2.0)
 
 include_directories(${CMAKE_INCLUDE_CURRENT_DIR})
 
 file(GLOB_RECURSE SRCS LIST_DIRECTORIES false *.cpp)
 file(GLOB_RECURSE MPV_SRCS LIST_DIRECTORIES false ../backends/mpv/*.cpp)
+file(GLOB_RECURSE MEDIAPLAYER_SRCS LIST_DIRECTORIES false ../backends/mediaplayer/*.cpp)
 file(GLOB_RECURSE HWDEC_SRCS ../common/hwdec_probe.cpp)
-list(APPEND SRCS player_widget.cpp ${MPV_SRCS} ${HWDEC_SRCS})
+list(APPEND SRCS player_widget.cpp ${MPV_SRCS} ${MEDIAPLAYER_SRCS} ${HWDEC_SRCS})
 
 add_library(${CMD_NAME} SHARED ${SRCS})
 set_target_properties(${CMD_NAME} PROPERTIES VERSION 0.1.0 SOVERSION 0.1)
 
 target_include_directories(${CMD_NAME} PUBLIC
-    ${PROJECT_SOURCE_DIR}/../common ${PROJECT_SOURCE_DIR}/../backends/mpv)
+    ${PROJECT_SOURCE_DIR}/../common ${PROJECT_SOURCE_DIR}/../backends/mediaplayer ${PROJECT_SOURCE_DIR}/../backends/mpv /usr/include/glib-2.0 /usr/include/gstreamer-1.0)
 
 target_link_libraries(${CMD_NAME} PkgConfig::Dtk Qt5::Widgets Qt5::Concurrent
-    Qt5::Network Qt5::X11Extras Qt5::Sql Qt5::Svg Qt5::DBus PkgConfig::AV
-    ${FFTHUMB_LIBRARIES} GL)
+    Qt5::Network Qt5::X11Extras Qt5::Sql Qt5::Svg Qt5::Multimedia Qt5::MultimediaWidgets Qt5::DBus PkgConfig::Gst GL)
 #target_link_libraries(${CMD_NAME} PkgConfig::Dtk Qt5::Widgets Qt5::Concurrent
 #    Qt5::Network Qt5::X11Extras Qt5::Sql Qt5::DBus PkgConfig::AV GL png jpeg)

=== tests/deepin-movie-platform/CMakeLists.txt ===
--- 
+++ 
@@ -16,7 +16,7 @@
 add_definitions( -DUSE_TEST )
 
 # 设置Qt模块
-set(QtModule Core Gui Widgets Network X11Extras PrintSupport DBus Sql Svg Concurrent LinguistTools Test)
+set(QtModule Core Gui Widgets Network X11Extras PrintSupport DBus Sql Svg Multimedia MultimediaWidgets Concurrent LinguistTools Test)
 
 # 设置工程名字
 project(deepin-movie-platform-test)
@@ -39,6 +39,7 @@
 include_directories(../../src/vendor)
 include_directories(../../src/backends)
 include_directories(../../src/backends/mpv)
+include_directories(../../src/backends/mediaplayer)
 
 #add_subdirectory(googletest)
 
@@ -51,6 +52,7 @@
     ../../src/libdmr/*.cpp
     ../../src/vendor/*.cpp
     ../../src/backends/mpv/*.cpp
+    ../../src/backends/mediaplayer/*.cpp
     ../../src/backends/*.cpp
     )
 
@@ -125,14 +127,14 @@
 #    PkgConfig::AV pthread GL)
 # 检查第三方库(这里检查了名字为dtkwidget的库和名字为dtkgui的库)，然后取名3rd_lib
 pkg_check_modules(3rd_lib REQUIRED
-        dtkwidget dtkgui libffmpegthumbnailer
-        libpulse dvdnav gsettings-qt  mpv x11 xext xtst xcb gl
-        libavformat libavcodec libavutil
+        dtkwidget dtkgui
+        libpulse dvdnav gsettings-qt x11 xext xtst xcb gl
         xcb-aux xcb-proto xcb-ewmh xcb-shape mpris-qt5 dbusextended-qt5 libva libva-x11
+        gstreamer-1.0 glib-2.0 gstreamer-pbutils-1.0
         )
     #libpulse-simple xcb-aux gtest
 # 添加第三方库的所有文件夹路径到工程中来(注意 *_INCLUDE_DIRS)
-target_include_directories(${PROJECT_NAME} PUBLIC ${3rd_lib_INCLUDE_DIRS} )
+target_include_directories(${PROJECT_NAME} PUBLIC ${3rd_lib_INCLUDE_DIRS})
 
 # 将第三方库链接进来(注意 *_LIBRARIES)
 target_link_libraries(${PROJECT_NAME} ${3rd_lib_LIBRARIES}  Qt5::GuiPrivate)

=== tests/deepin-movie/CMakeLists.txt ===
--- 
+++ 
@@ -16,7 +16,7 @@
 add_definitions( -DUSE_TEST )
 
 # 设置Qt模块
-set(QtModule Core Gui Widgets Network X11Extras PrintSupport DBus Sql Svg Concurrent LinguistTools Test)
+set(QtModule Core Gui Widgets Network X11Extras PrintSupport DBus Sql Svg Multimedia MultimediaWidgets Concurrent LinguistTools Test)
 
 # 设置工程名字
 project(deepin-movie-test)
@@ -39,6 +39,7 @@
 include_directories(../../src/vendor)
 include_directories(../../src/backends)
 include_directories(../../src/backends/mpv)
+include_directories(../../src/backends/mediaplayer)
 
 #add_subdirectory(googletest)
 
@@ -51,6 +52,7 @@
     ../../src/libdmr/*.cpp
     ../../src/vendor/*.cpp
     ../../src/backends/mpv/*.cpp
+    ../../src/backends/mediaplayer/*.cpp
     ../../src/backends/*.cpp
     )
 
@@ -126,14 +128,14 @@
 #    PkgConfig::AV pthread GL)
 # 检查第三方库(这里检查了名字为dtkwidget的库和名字为dtkgui的库)，然后取名3rd_lib
 pkg_check_modules(3rd_lib REQUIRED
-        dtkwidget dtkgui libffmpegthumbnailer
-        libpulse dvdnav gsettings-qt  mpv x11 xext xtst xcb gl
-        libavformat libavcodec libavutil
+        dtkwidget dtkgui
+        libpulse dvdnav gsettings-qt x11 xext xtst xcb gl
         xcb-aux xcb-proto xcb-ewmh xcb-shape mpris-qt5 dbusextended-qt5 libva libva-x11
+        gstreamer-1.0 glib-2.0 gstreamer-pbutils-1.0
         )
     #libpulse-simple xcb-aux gtest
 # 添加第三方库的所有文件夹路径到工程中来(注意 *_INCLUDE_DIRS)
-target_include_directories(${PROJECT_NAME} PUBLIC ${3rd_lib_INCLUDE_DIRS} )
+target_include_directories(${PROJECT_NAME} PUBLIC ${3rd_lib_INCLUDE_DIRS})
 
 # 将第三方库链接进来(注意 *_LIBRARIES)
 target_link_libraries(${PROJECT_NAME} ${3rd_lib_LIBRARIES}  Qt5::GuiPrivate)

=== tests/ut_dmr-test/CMakeLists.txt ===
--- 
+++ 
@@ -24,7 +24,6 @@
 find_package(Qt5 REQUIRED ${QtModule})
 
 pkg_check_modules(Dtk REQUIRED IMPORTED_TARGET dtkwidget)
-pkg_check_modules(AV REQUIRED IMPORTED_TARGET libavformat libavutil libavcodec)
 
 include_directories(../../examples/test)
 include_directories(../../src)
@@ -69,9 +68,8 @@
 # 使用第三方库需要用到的一个包
 find_package(PkgConfig REQUIRED)
 pkg_check_modules(3rd_lib REQUIRED
-        dtkwidget dtkgui libffmpegthumbnailer
-        libpulse dvdnav gsettings-qt  mpv x11 xext xtst xcb gl
-        libavformat libavcodec libavutil
+        dtkwidget dtkgui
+        libpulse dvdnav gsettings-qt x11 xext xtst xcb gl
         xcb-aux xcb-proto xcb-ewmh xcb-shape mpris-qt5 dbusextended-qt5 libva libva-x11
         )
     #libpulse-simple xcb-aux gtest

=== debian/changelog ===
deepin-movie-reborn (5.10.8-1) unstable; urgency=medium

  * New upstream release.
  * debian/rules:
    + Explicitly disable LTO build. (Closes: #1015384)
    + Drop unnecessary override on dh_missing.

 -- Boyuan Yang <byang@debian.org>  Mon, 15 Aug 2022 13:26:12 -0400

deepin-movie-reborn (5.10.5-1) unstable; urgency=medium

  * debian/control:
    + Add build-dep package.
    + Bump Standards-Version to 4.6.1.0.
  * debian/copyright:
    + Update Upstream-Contact.
    + Update files copyright information.
  * debian/libdmr0.1.shlibs:
    + Update version.
  * debian/patches:
    + Remove useless patches.
    + Update other patches.
  * debian/upstream/metadata:
    + Update Bug-Database and Bug-Submit address.

 -- Clay Stan <claystan97@gmail.com>  Thu, 14 Jul 2022 17:26:34 +0800

deepin-movie-reborn (5.7.15-3.1) unstable; urgency=medium

  * Non-maintainer upload.
  * debian/control: Remove manual dependencies on libav* (Closes: #1014198)
    These dependencies are already added by ${shlibs:Depends}.

 -- Sebastian Ramacher <sramacher@debian.org>  Mon, 11 Jul 2022 22:33:15 +0200

deepin-movie-reborn (5.7.15-3) unstable; urgency=medium

  * debian/patches:
    + Add patch to fix FTBFS with ffmpeg 5.0 (Closes: #1004807).

 -- Arun Kumar Pariyar <openarungeek@gmail.com>  Tue, 12 Apr 2022 14:45:15 +0545

=== debian/control ===
Source: deepin-movie-reborn
Section: video
Priority: optional
Maintainer: Debian Deepin Packaging Team <pkg-deepin-devel@lists.alioth.debian.org>
Uploaders:
 Yangfl <mmyangfl@gmail.com>,
 Boyuan Yang <byang@debian.org>,
 Yanhao Mo <yanhaocs@gmail.com>,
 Arun Kumar Pariyar <openarungeek@gmail.com>,
 Clay Stan <claystan97@gmail.com>,
Build-Depends:
 cmake,
 debhelper-compat (= 13),
 libavcodec-dev,
 libavformat-dev,
 libavutil-dev,
 libdbusextended-qt5-dev,
 libdtkcore5-bin (>=5.5~),
 libdtkwidget-dev (>=5.5~),
 libdvdnav-dev,
 libffmpegthumbnailer-dev,
 libgsettings-qt-dev,
 libgstreamer1.0-dev,
 libgstreamer-plugins-base1.0-dev,
 libmpris-qt5-dev,
 libmpv-dev,
 libpulse-dev,
 libqt5sql5-sqlite,
 libqt5svg5-dev,
 libqt5x11extras5-dev,
 libxcb-ewmh-dev,
 libxcb-shape0-dev,
 libxcb-util-dev,
 libxcb1-dev,
 libxtst-dev,
 libva-dev,
 pkg-config,
 qtmultimedia5-dev,
 qttools5-dev,
 qttools5-dev-tools,
 x11proto-record-dev,
 xcb-proto,
Rules-Requires-Root: no
Standards-Version: 4.6.1.0
Homepage: https://github.com/linuxdeepin/deepin-movie-reborn
Vcs-Git: https://salsa.debian.org/pkg-deepin-team/deepin-movie-reborn.git
Vcs-Browser: https://salsa.debian.org/pkg-deepin-team/deepin-movie-reborn

Package: deepin-movie
Architecture: any
Depends:
 libdmr0.1 (= ${binary:Version}),
 libffmpegthumbnailer4v5,
 libmpris-qt5-1 (>=0.1.0.1),
 libmpv1 (>=0.29),
 libpulse0 (>=0.99.1),
 libqt5concurrent5 (>=5.6.0~rc),
 libgstreamer1.0-0,
 libgstreamer-plugins-base1.0-0,
 va-driver-all,
 ${misc:Depends},
 ${shlibs:Depends},
Recommends: libgpuinfo
Description: Deepin movie player
 Deepin Movie provides an intuitive easy to use operation interface and rich
 complete shortcuts. You can complete all play operations by keyboard, which
 will make you thoroughly get rid of the constraint of mouse click. Video files
 in various formats can be played through Deepin Movie, and you can use the
 streaming function to easily enjoy online video resources.
 .
 This package is part of DDE (Deepin Desktop Environment).

Package: libdmr-dev
Section: libdevel
Architecture: any
Depends:
 libdmr0.1 (= ${binary:Version}),
 libgsettings-qt-dev,
 ${misc:Depends},
Multi-Arch: same
Description: Deepin movie player - widget library (development files)
 Deepin Movie provides an intuitive easy to use operation interface and rich
 complete shortcuts. You can complete all play operations by keyboard, which
 will make you thoroughly get rid of the constraint of mouse click. Video files
 in various formats can be played through Deepin Movie, and you can use the
 streaming function to easily enjoy online video resources.
 .
 This package is part of DDE (Deepin Desktop Environment).
 .
 This package contains the header files for the widget library.

Package: libdmr0.1
Section: libs
Architecture: any
Multi-Arch: same
Depends:
 libffmpegthumbnailer4v5,
 libmpris-qt5-1 (>=0.1.0.1),
 libmpv1 (>=0.29),
 libpulse0 (>=0.99.1),
 libqt5concurrent5 (>=5.6.0~rc),
 libgstreamer-plugins-base1.0-0,
 ${misc:Depends},
 ${shlibs:Depends},
Description: Deepin movie player - widget library
 Deepin Movie provides an intuitive easy to use operation interface and rich
 complete shortcuts. You can complete all play operations by keyboard, which
 will make you thoroughly get rid of the constraint of mouse click. Video files
 in various formats can be played through Deepin Movie, and you can use the
 streaming function to easily enjoy online video resources.
 .
 This package is part of DDE (Deepin Desktop Environment).
 .
 This package contains the widget library.

=== debian/rules ===
#!/usr/bin/make -f
#export DH_VERBOSE = 1

include /usr/share/dpkg/default.mk

export DEB_BUILD_MAINT_OPTIONS = hardening=+all optimize=-lto
export DEB_CXXFLAGS_MAINT_APPEND = -Wl,-z,now
export QT_SELECT := 5

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- \
	  -DCMAKE_BUILD_TYPE=Release \
	  -DCMAKE_INSTALL_PREFIX=/usr \
      -DAPP_VERSION=$(DEB_VERSION_UPSTREAM) -DVERSION=$(DEB_VERSION_UPSTREAM) LIB_INSTALL_DIR=/usr/lib/$(DEB_HOST_MULTIARCH)
